// Print1View.cpp : implementation of the CPrint1View class
//

#include "stdafx.h"
#include "Print1.h"

#include "Print1Doc.h"
#include "Print1View.h"
#include ".\print1view.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPrint1View

IMPLEMENT_DYNCREATE(CPrint1View, CView)

BEGIN_MESSAGE_MAP(CPrint1View, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
    ON_WM_LBUTTONDOWN()
    ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()

// CPrint1View construction/destruction

CPrint1View::CPrint1View()
: m_nRectPerPage(0)
{
	// TODO: add construction code here

}

CPrint1View::~CPrint1View()
{
}

BOOL CPrint1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CPrint1View drawing

void CPrint1View::OnDraw(CDC* pDC)
{
    CPrint1Doc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    //pDC->SetMapMode(MM_LOENGLISH);

    CString s;
    s.Format("%d", pDoc->m_numRects);
    pDC->TextOut(300, -100, s);

    for (int x=0; x<pDoc->m_numRects; ++x)
    {
        pDC->Rectangle(20, -(20+x*200),
            200, -(200+x*200));
		CString str;
		str.Format("%d",x);
		pDC->TextOut(40, -(40+x*200), str);
    }
}


// CPrint1View printing

BOOL CPrint1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPrint1View::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
    CPrint1Doc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

     int pageHeight = pDC->GetDeviceCaps(VERTRES);
     int logPixelsY = pDC->GetDeviceCaps(LOGPIXELSY);
     int rectHeight = (int)(2 * logPixelsY);
	 int numPages = (pDoc->m_numRects * rectHeight - 1) / pageHeight + 1;
	 m_nRectPerPage = pageHeight/rectHeight;
	 pInfo->SetMaxPage(numPages);
}

void CPrint1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CPrint1View diagnostics

#ifdef _DEBUG
void CPrint1View::AssertValid() const
{
	CView::AssertValid();
}

void CPrint1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPrint1Doc* CPrint1View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPrint1Doc)));
	return (CPrint1Doc*)m_pDocument;
}
#endif //_DEBUG


// CPrint1View message handlers

void CPrint1View::OnLButtonDown(UINT nFlags, CPoint point)
{
     CPrint1Doc* pDoc = GetDocument();
     ASSERT_VALID(pDoc);

     pDoc->m_numRects++;
     Invalidate();

    CView::OnLButtonDown(nFlags, point);
}

void CPrint1View::OnRButtonDown(UINT nFlags, CPoint point)
{
     CPrint1Doc* pDoc = GetDocument();
     ASSERT_VALID(pDoc);

     if (pDoc->m_numRects > 0)
     {
          pDoc->m_numRects--;
          Invalidate();
     }

    CView::OnRButtonDown(nFlags, point);
}

void CPrint1View::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	pDC->SetMapMode(MM_LOENGLISH);

    CView::OnPrepareDC(pDC, pInfo);

}

void CPrint1View::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: Add your specialized code here and/or call the base class
	CPrint1Doc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

	int nStart = (pInfo->m_nCurPage - 1) * m_nRectPerPage;
	int nEnd = (pInfo->m_nCurPage) * m_nRectPerPage;
	if (nEnd > pDoc->m_numRects) {
		nEnd = pDoc->m_numRects;
	}

	if (nStart == 0) {
		CString s;
		s.Format("%d", pDoc->m_numRects);
		pDC->TextOut(300, -100, s);
	}

    for (int x=nStart; x<nEnd; ++x)
    {
        pDC->Rectangle(20, -(20+(x-nStart)*200),
            200, -(200+(x-nStart)*200));
		CString str;
		str.Format("%d",x);
		pDC->TextOut(40, -(40+(x-nStart)*200), str);
    }
}
